<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: scconf.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_7a879d24cd3db3969353e5fb0ef35f10.html">scconf</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">scconf.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="scconf_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * $Id$</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Copyright (C) 2002</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Antti Tapaninen &lt;aet@cc.hut.fi&gt;</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * Originally based on source by Timo Sirainen &lt;tss@iki.fi&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * This library is free software; you can redistribute it and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * modify it under the terms of the GNU Lesser General Public</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * License as published by the Free Software Foundation; either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * version 2.1 of the License, or (at your option) any later version.</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * This library is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * Lesser General Public License for more details.</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * You should have received a copy of the GNU Lesser General Public</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * License along with this library; if not, write to the Free Software</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef _SC_CONF_H</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define _SC_CONF_H</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="struct__scconf__entry.html">   31</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__scconf__entry.html">_scconf_entry</a> {</div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="struct__scconf__entry.html#a8f8f80d37794cde9472343e4487ba3eb">   32</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="struct__scconf__entry.html#a8f8f80d37794cde9472343e4487ba3eb">name</a>;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="struct__scconf__entry.html#a4bfea42429249a1f65204f0c0f34704a">   33</a></span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="struct__scconf__entry.html#a4bfea42429249a1f65204f0c0f34704a">type</a>;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="struct__scconf__entry.html#ac92588540e8c1d014a08cd8a45462b19">   34</a></span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="struct__scconf__entry.html#ac92588540e8c1d014a08cd8a45462b19">flags</a>;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="struct__scconf__entry.html#a14c65b9f2783c6f6dafdaaa372329e4d">   35</a></span>&#160;        <span class="keywordtype">void</span> *<a class="code" href="struct__scconf__entry.html#a14c65b9f2783c6f6dafdaaa372329e4d">parm</a>;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="struct__scconf__entry.html#a9ce2ec4812a92cb6ab39f6e81e9173a9">   36</a></span>&#160;        <span class="keywordtype">void</span> *<a class="code" href="struct__scconf__entry.html#a9ce2ec4812a92cb6ab39f6e81e9173a9">arg</a>;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;} <a class="code" href="scconf_8h.html#aef840455dccc4ab6d13294b2877a0986">scconf_entry</a>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment">/* Entry flags */</span></div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="scconf_8h.html#aa3d7a853fc4de1da92b869b434444cfb">   40</a></span>&#160;<span class="preprocessor">#define SCCONF_PRESENT          0x00000001</span></div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="scconf_8h.html#a227fca1be5ffbe20f3e7115a00e8c7d4">   41</a></span>&#160;<span class="preprocessor">#define SCCONF_MANDATORY        0x00000002</span></div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="scconf_8h.html#a4e278abdf4e6219b004223e3d786577e">   42</a></span>&#160;<span class="preprocessor">#define SCCONF_ALLOC            0x00000004</span></div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="scconf_8h.html#ae9f05b0ea1beed4b79994d5f2ea027a3">   43</a></span>&#160;<span class="preprocessor">#define SCCONF_ALL_BLOCKS       0x00000008</span></div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="scconf_8h.html#a6013183490843fdd8623853175a19468">   44</a></span>&#160;<span class="preprocessor">#define SCCONF_VERBOSE          0x00000010      </span><span class="comment">/* For debugging purposes only */</span><span class="preprocessor"></span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment">/* Entry types */</span></div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="scconf_8h.html#a82e14b5ece963515a1b83c855c0e23c1">   47</a></span>&#160;<span class="preprocessor">#define SCCONF_CALLBACK         1</span></div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="scconf_8h.html#a6133521cf1a9e13c39bb3d70dec5f9b3">   48</a></span>&#160;<span class="preprocessor">#define SCCONF_BLOCK            2</span></div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="scconf_8h.html#a73301309d4e2fae647e0cacad10f305f">   49</a></span>&#160;<span class="preprocessor">#define SCCONF_LIST             3</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="scconf_8h.html#abe880248960e5680c63e3a4ecdc3ea6a">   51</a></span>&#160;<span class="preprocessor">#define SCCONF_BOOLEAN          11</span></div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="scconf_8h.html#a43d3572cfb467a8d41a4bfccfe091d90">   52</a></span>&#160;<span class="preprocessor">#define SCCONF_INTEGER          12</span></div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="scconf_8h.html#a090e094f84487e89755dbe82c6b12057">   53</a></span>&#160;<span class="preprocessor">#define SCCONF_STRING           13</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="scconf_8h.html#aa1a6aa691197930df0da465dabadbc7d">   55</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__scconf__block.html">_scconf_block</a> <a class="code" href="struct__scconf__block.html">scconf_block</a>;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="struct__scconf__list.html">   57</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__scconf__list.html">_scconf_list</a> {</div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="struct__scconf__list.html#a3afd6a91ed4d8bdffcaa8e57e1557970">   58</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="struct__scconf__list.html">_scconf_list</a> *<a class="code" href="struct__scconf__list.html#a3afd6a91ed4d8bdffcaa8e57e1557970">next</a>;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="struct__scconf__list.html#a91a70b77df95bd8b0830b49a094c2acb">   59</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="struct__scconf__list.html#a91a70b77df95bd8b0830b49a094c2acb">data</a>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;} <a class="code" href="scconf_8h.html#aa8f1073e79bcffa437a0050fad1a2b06">scconf_list</a>;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="scconf_8h.html#a18c56299c4b5189ed5c0ce24757c4a79">   62</a></span>&#160;<span class="preprocessor">#define SCCONF_ITEM_TYPE_COMMENT        0       </span><span class="comment">/* key = NULL, comment */</span><span class="preprocessor"></span></div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="scconf_8h.html#a0950c0ad81139510dfc4a1c9e711b866">   63</a></span>&#160;<span class="preprocessor">#define SCCONF_ITEM_TYPE_BLOCK          1       </span><span class="comment">/* key = key, block */</span><span class="preprocessor"></span></div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="scconf_8h.html#afec03a8f44af732ffe0e992bb62cfce0">   64</a></span>&#160;<span class="preprocessor">#define SCCONF_ITEM_TYPE_VALUE          2       </span><span class="comment">/* key = key, list */</span><span class="preprocessor"></span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="struct__scconf__item.html">   66</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__scconf__item.html">_scconf_item</a> {</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="struct__scconf__item.html#af8affd003f82b7208a580ee5cb56da0c">   67</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="struct__scconf__item.html">_scconf_item</a> *<a class="code" href="struct__scconf__item.html#af8affd003f82b7208a580ee5cb56da0c">next</a>;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="struct__scconf__item.html#ac765329451135abec74c45e1897abf26">   68</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="struct__scconf__item.html#ac765329451135abec74c45e1897abf26">type</a>;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="struct__scconf__item.html#a5892a9181e6a332f84d27aecd41dcd12">   69</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="struct__scconf__item.html#a5892a9181e6a332f84d27aecd41dcd12">key</a>;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">union </span>{</div><div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="struct__scconf__item.html#a25dae25c3bf9b28d54eb4df7afb2a491">   71</a></span>&#160;                <span class="keywordtype">char</span> *<a class="code" href="struct__scconf__item.html#a25dae25c3bf9b28d54eb4df7afb2a491">comment</a>;</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="struct__scconf__item.html#abba81c977d8901de66b169a60d8481e1">   72</a></span>&#160;                <a class="code" href="struct__scconf__block.html">scconf_block</a> *<a class="code" href="struct__scconf__item.html#abba81c977d8901de66b169a60d8481e1">block</a>;</div><div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="struct__scconf__item.html#aaa2544dbadef96351e62c5a00e20646b">   73</a></span>&#160;                <a class="code" href="struct__scconf__list.html">scconf_list</a> *<a class="code" href="struct__scconf__item.html#aaa2544dbadef96351e62c5a00e20646b">list</a>;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        } value;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;} <a class="code" href="scconf_8h.html#a447deee631fbbcfd4736954f957faee2">scconf_item</a>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="struct__scconf__block.html">   77</a></span>&#160;<span class="keyword">struct </span><a class="code" href="struct__scconf__block.html">_scconf_block</a> {</div><div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="struct__scconf__block.html#a175c4cc967d747c1d07c892a1b0514d2">   78</a></span>&#160;        <a class="code" href="struct__scconf__block.html">scconf_block</a> *<a class="code" href="struct__scconf__block.html#a175c4cc967d747c1d07c892a1b0514d2">parent</a>;</div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="struct__scconf__block.html#a0c0f0d9b82294b198e07f8385904e1c2">   79</a></span>&#160;        <a class="code" href="struct__scconf__list.html">scconf_list</a> *<a class="code" href="struct__scconf__block.html#a0c0f0d9b82294b198e07f8385904e1c2">name</a>;</div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="struct__scconf__block.html#a54ab50335fc84a5327891453161d2a5a">   80</a></span>&#160;        <a class="code" href="struct__scconf__item.html">scconf_item</a> *<a class="code" href="struct__scconf__block.html#a54ab50335fc84a5327891453161d2a5a">items</a>;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;};</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="structscconf__context.html">   83</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="structscconf__context.html#aeac90097f29f7529968697163cea5c18">   84</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="structscconf__context.html#aeac90097f29f7529968697163cea5c18">filename</a>;</div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="structscconf__context.html#ac3e1795766a80ec63b157951b4b9a7d4">   85</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="structscconf__context.html#ac3e1795766a80ec63b157951b4b9a7d4">debug</a>;</div><div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="structscconf__context.html#a76f2e40a18edacf6582156a75296278a">   86</a></span>&#160;        <a class="code" href="struct__scconf__block.html">scconf_block</a> *<a class="code" href="structscconf__context.html#a76f2e40a18edacf6582156a75296278a">root</a>;</div><div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="structscconf__context.html#a39aebac8fca50ea12a14719c9a36a645">   87</a></span>&#160;        <span class="keywordtype">char</span> *<a class="code" href="structscconf__context.html#a39aebac8fca50ea12a14719c9a36a645">errmsg</a>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;} <a class="code" href="structscconf__context.html">scconf_context</a>;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">/* Allocate scconf_context</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment"> * The filename can be NULL</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="keyword">extern</span> <a class="code" href="structscconf__context.html">scconf_context</a> *<a class="code" href="scconf_8h.html#aa6af95185d97705bd16b2352a7085dd5">scconf_new</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *filename);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="comment">/* Free scconf_context</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="scconf_8h.html#a7eec7e86ab0151ef1be5718ec01088f8">scconf_free</a>(<a class="code" href="structscconf__context.html">scconf_context</a> * config);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">/* Parse configuration</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment"> * Returns 1 = ok, 0 = error, -1 = error opening config file</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#af464702b43c5ff303ebbde427a6f66ba">scconf_parse</a>(<a class="code" href="structscconf__context.html">scconf_context</a> * config);</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="comment">/* Parse a static configuration string</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="comment"> * Returns 1 = ok, 0 = error</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#a871df157bcfd14791814d8a2f373598d">scconf_parse_string</a>(<a class="code" href="structscconf__context.html">scconf_context</a> * config, <span class="keyword">const</span> <span class="keywordtype">char</span> *<span class="keywordtype">string</span>);</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment">/* Parse entries</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#af43e08f4b56609d353887b3bc3e1181b">scconf_parse_entries</a>(<span class="keyword">const</span> <a class="code" href="structscconf__context.html">scconf_context</a> * config, <span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <a class="code" href="struct__scconf__entry.html">scconf_entry</a> * entry);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">/* Write config to a file</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="comment"> * If the filename is NULL, use the config-&gt;filename</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="comment"> * Returns 0 = ok, else = errno</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#a1227ae9b24743629b9996b2f4af30083">scconf_write</a>(<a class="code" href="structscconf__context.html">scconf_context</a> * config, <span class="keyword">const</span> <span class="keywordtype">char</span> *filename);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment">/* Write configuration entries to block</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#a1122f8661ba0177249d248188ba25c18">scconf_write_entries</a>(<a class="code" href="structscconf__context.html">scconf_context</a> * config, <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <a class="code" href="struct__scconf__entry.html">scconf_entry</a> * entry);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="comment">/* Find a block by the item_name</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="comment"> * If the block is NULL, the root block is used</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">extern</span> <span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> *<a class="code" href="scconf_8h.html#a44356f410df33b5d4566cd7748014402">scconf_find_block</a>(<span class="keyword">const</span> <a class="code" href="structscconf__context.html">scconf_context</a> * config, <span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *item_name);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment">/* Find blocks by the item_name</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="comment"> * If the block is NULL, the root block is used</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="comment"> * The key can be used to specify what the blocks first name should be</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keyword">extern</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> **<a class="code" href="scconf_8h.html#aea883f7131774fcff6ea1dbabd74c963">scconf_find_blocks</a>(<span class="keyword">const</span> <a class="code" href="structscconf__context.html">scconf_context</a> * config, <span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *item_name, <span class="keyword">const</span> <span class="keywordtype">char</span> *key);</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="comment">/* Get a list of values for option</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="keyword">extern</span> <span class="keyword">const</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> *<a class="code" href="scconf_8h.html#a03e68e156734f70e0c8d100f47825d98">scconf_find_list</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *option);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="comment">/* Return the first string of the option</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="comment"> * If no option found, return def</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="keyword">extern</span> <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="scconf_8h.html#ab915bae0be5ebaca910513630c5d6e81">scconf_get_str</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *option, <span class="keyword">const</span> <span class="keywordtype">char</span> *def);</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">/* Return the first value of the option as integer</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment"> * If no option found, return def</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#aeb62022f2fff253f39f1078dacf42f32">scconf_get_int</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *option, <span class="keywordtype">int</span> def);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="comment">/* Return the first value of the option as boolean</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="comment"> * If no option found, return def</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#ac2d4577c50dd488789375a15c8bb189d">scconf_get_bool</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *option, <span class="keywordtype">int</span> def);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="comment">/* Write value to a block as a string</span></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="keyword">extern</span> <span class="keyword">const</span> <span class="keywordtype">char</span> *<a class="code" href="scconf_8h.html#a7704845802ec646d79a1e1975d69483f">scconf_put_str</a>(<a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *option, <span class="keyword">const</span> <span class="keywordtype">char</span> *value);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment">/* Write value to a block as an integer</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#ab1965c4a7adddaf1672a98d880bd6c21">scconf_put_int</a>(<a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *option, <span class="keywordtype">int</span> value);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment">/* Write value to a block as a boolean</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#a86a492b8747e032923064cc23de2f1b1">scconf_put_bool</a>(<a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *option, <span class="keywordtype">int</span> value);</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="comment">/* Add block structure</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="comment"> * If the block is NULL, the root block is used</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="keyword">extern</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> *<a class="code" href="scconf_8h.html#ac67f138d996c47a8385dd6b0d6cc72a9">scconf_block_add</a>(<a class="code" href="structscconf__context.html">scconf_context</a> * config, <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <span class="keyword">const</span> <span class="keywordtype">char</span> *key, <span class="keyword">const</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> *<a class="code" href="struct__scconf__entry.html#a8f8f80d37794cde9472343e4487ba3eb">name</a>);</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="comment">/* Copy block structure (recursive)</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keyword">extern</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> *<a class="code" href="scconf_8h.html#a3725160579285f52c16db9658e668979">scconf_block_copy</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__block.html">scconf_block</a> * src, <a class="code" href="struct__scconf__block.html">scconf_block</a> ** dst);</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment">/* Free block structure (recursive)</span></div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="scconf_8h.html#a4da19211d35bbe397777b33d4f83137a">scconf_block_destroy</a>(<a class="code" href="struct__scconf__block.html">scconf_block</a> * block);</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="comment">/* Add item to block structure</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="comment"> * If the block is NULL, the root block is used</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="keyword">extern</span> <a class="code" href="struct__scconf__item.html">scconf_item</a> *<a class="code" href="scconf_8h.html#ad91ebfa84fe6f6e20a513c6a8fc35de5">scconf_item_add</a>(<a class="code" href="structscconf__context.html">scconf_context</a> * config, <a class="code" href="struct__scconf__block.html">scconf_block</a> * block, <a class="code" href="struct__scconf__item.html">scconf_item</a> * item, <span class="keywordtype">int</span> <a class="code" href="struct__scconf__entry.html#a4bfea42429249a1f65204f0c0f34704a">type</a>, <span class="keyword">const</span> <span class="keywordtype">char</span> *key, <span class="keyword">const</span> <span class="keywordtype">void</span> *data);</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;<span class="comment">/* Copy item structure (recursive)</span></div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="keyword">extern</span> <a class="code" href="struct__scconf__item.html">scconf_item</a> *<a class="code" href="scconf_8h.html#a0a2f9633f667675f98dfb2fc220dfc10">scconf_item_copy</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__item.html">scconf_item</a> * src, <a class="code" href="struct__scconf__item.html">scconf_item</a> ** dst);</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="comment">/* Free item structure (recursive)</span></div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="scconf_8h.html#a3f0f7912d88f836e7553ff489e80892d">scconf_item_destroy</a>(<a class="code" href="struct__scconf__item.html">scconf_item</a> * item);</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="comment">/* Add a new value to the list</span></div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="keyword">extern</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> *<a class="code" href="scconf_8h.html#a1067cec0efd2bbaa3a66016bbc342d72">scconf_list_add</a>(<a class="code" href="struct__scconf__list.html">scconf_list</a> ** list, <span class="keyword">const</span> <span class="keywordtype">char</span> *value);</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment">/* Copy list structure</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="keyword">extern</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> *<a class="code" href="scconf_8h.html#a7fb8e0bc1859a8545ce57d99c9c4087b">scconf_list_copy</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> * src, <a class="code" href="struct__scconf__list.html">scconf_list</a> ** dst);</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="comment">/* Free list structure</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="scconf_8h.html#abed028d5efec452b8c2a66ed574e13c5">scconf_list_destroy</a>(<a class="code" href="struct__scconf__list.html">scconf_list</a> * list);</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;<span class="comment">/* Return the length of an list array</span></div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#a7ba3f9b01650f48f7f663054f55e3aa1">scconf_list_array_length</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> * list);</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="comment">/* Return the combined length of the strings on all arrays</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="scconf_8h.html#adc8908fbac17d11da159c5d1f9345dde">scconf_list_strings_length</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> * list);</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="comment">/* Return an allocated string that contains all</span></div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="comment"> * the strings in a list separated by the filler</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="comment"> * The filler can be NULL</span></div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="keyword">extern</span> <span class="keywordtype">char</span> *<a class="code" href="scconf_8h.html#afe1c8e7c60852a3446e631fd4eeb4644">scconf_list_strdup</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> * list, <span class="keyword">const</span> <span class="keywordtype">char</span> *filler);</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="comment">/* Returns an allocated array of const char *pointers to</span></div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;<span class="comment"> * list elements.</span></div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="comment"> * Last pointer is NULL</span></div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="comment"> * Array must be freed, but pointers to strings belong to scconf_list</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="keyword">extern</span> <span class="keyword">const</span> <span class="keywordtype">char</span> **<a class="code" href="scconf_8h.html#a6bf939fee559def4804f767a571c0002">scconf_list_toarray</a>(<span class="keyword">const</span> <a class="code" href="struct__scconf__list.html">scconf_list</a> * list);</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;}</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="scconf_8h_html_a03e68e156734f70e0c8d100f47825d98"><div class="ttname"><a href="scconf_8h.html#a03e68e156734f70e0c8d100f47825d98">scconf_find_list</a></div><div class="ttdeci">const scconf_list * scconf_find_list(const scconf_block *block, const char *option)</div></div>
<div class="ttc" id="scconf_8h_html_afe1c8e7c60852a3446e631fd4eeb4644"><div class="ttname"><a href="scconf_8h.html#afe1c8e7c60852a3446e631fd4eeb4644">scconf_list_strdup</a></div><div class="ttdeci">char * scconf_list_strdup(const scconf_list *list, const char *filler)</div></div>
<div class="ttc" id="struct__scconf__block_html_a54ab50335fc84a5327891453161d2a5a"><div class="ttname"><a href="struct__scconf__block.html#a54ab50335fc84a5327891453161d2a5a">_scconf_block::items</a></div><div class="ttdeci">scconf_item * items</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00080">scconf.h:80</a></div></div>
<div class="ttc" id="struct__scconf__entry_html_a4bfea42429249a1f65204f0c0f34704a"><div class="ttname"><a href="struct__scconf__entry.html#a4bfea42429249a1f65204f0c0f34704a">_scconf_entry::type</a></div><div class="ttdeci">unsigned int type</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00033">scconf.h:33</a></div></div>
<div class="ttc" id="structscconf__context_html_aeac90097f29f7529968697163cea5c18"><div class="ttname"><a href="structscconf__context.html#aeac90097f29f7529968697163cea5c18">scconf_context::filename</a></div><div class="ttdeci">char * filename</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00084">scconf.h:84</a></div></div>
<div class="ttc" id="scconf_8h_html_a1227ae9b24743629b9996b2f4af30083"><div class="ttname"><a href="scconf_8h.html#a1227ae9b24743629b9996b2f4af30083">scconf_write</a></div><div class="ttdeci">int scconf_write(scconf_context *config, const char *filename)</div></div>
<div class="ttc" id="struct__scconf__list_html_a3afd6a91ed4d8bdffcaa8e57e1557970"><div class="ttname"><a href="struct__scconf__list.html#a3afd6a91ed4d8bdffcaa8e57e1557970">_scconf_list::next</a></div><div class="ttdeci">struct _scconf_list * next</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00058">scconf.h:58</a></div></div>
<div class="ttc" id="scconf_8h_html_aa6af95185d97705bd16b2352a7085dd5"><div class="ttname"><a href="scconf_8h.html#aa6af95185d97705bd16b2352a7085dd5">scconf_new</a></div><div class="ttdeci">scconf_context * scconf_new(const char *filename)</div></div>
<div class="ttc" id="scconf_8h_html_aef840455dccc4ab6d13294b2877a0986"><div class="ttname"><a href="scconf_8h.html#aef840455dccc4ab6d13294b2877a0986">scconf_entry</a></div><div class="ttdeci">struct _scconf_entry scconf_entry</div></div>
<div class="ttc" id="scconf_8h_html_a1067cec0efd2bbaa3a66016bbc342d72"><div class="ttname"><a href="scconf_8h.html#a1067cec0efd2bbaa3a66016bbc342d72">scconf_list_add</a></div><div class="ttdeci">scconf_list * scconf_list_add(scconf_list **list, const char *value)</div></div>
<div class="ttc" id="structscconf__context_html_ac3e1795766a80ec63b157951b4b9a7d4"><div class="ttname"><a href="structscconf__context.html#ac3e1795766a80ec63b157951b4b9a7d4">scconf_context::debug</a></div><div class="ttdeci">int debug</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00085">scconf.h:85</a></div></div>
<div class="ttc" id="scconf_8h_html_a3725160579285f52c16db9658e668979"><div class="ttname"><a href="scconf_8h.html#a3725160579285f52c16db9658e668979">scconf_block_copy</a></div><div class="ttdeci">scconf_block * scconf_block_copy(const scconf_block *src, scconf_block **dst)</div></div>
<div class="ttc" id="struct__scconf__entry_html_a8f8f80d37794cde9472343e4487ba3eb"><div class="ttname"><a href="struct__scconf__entry.html#a8f8f80d37794cde9472343e4487ba3eb">_scconf_entry::name</a></div><div class="ttdeci">const char * name</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00032">scconf.h:32</a></div></div>
<div class="ttc" id="structscconf__context_html_a76f2e40a18edacf6582156a75296278a"><div class="ttname"><a href="structscconf__context.html#a76f2e40a18edacf6582156a75296278a">scconf_context::root</a></div><div class="ttdeci">scconf_block * root</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00086">scconf.h:86</a></div></div>
<div class="ttc" id="scconf_8h_html_a871df157bcfd14791814d8a2f373598d"><div class="ttname"><a href="scconf_8h.html#a871df157bcfd14791814d8a2f373598d">scconf_parse_string</a></div><div class="ttdeci">int scconf_parse_string(scconf_context *config, const char *string)</div></div>
<div class="ttc" id="scconf_8h_html_ac67f138d996c47a8385dd6b0d6cc72a9"><div class="ttname"><a href="scconf_8h.html#ac67f138d996c47a8385dd6b0d6cc72a9">scconf_block_add</a></div><div class="ttdeci">scconf_block * scconf_block_add(scconf_context *config, scconf_block *block, const char *key, const scconf_list *name)</div></div>
<div class="ttc" id="scconf_8h_html_adc8908fbac17d11da159c5d1f9345dde"><div class="ttname"><a href="scconf_8h.html#adc8908fbac17d11da159c5d1f9345dde">scconf_list_strings_length</a></div><div class="ttdeci">int scconf_list_strings_length(const scconf_list *list)</div></div>
<div class="ttc" id="scconf_8h_html_a3f0f7912d88f836e7553ff489e80892d"><div class="ttname"><a href="scconf_8h.html#a3f0f7912d88f836e7553ff489e80892d">scconf_item_destroy</a></div><div class="ttdeci">void scconf_item_destroy(scconf_item *item)</div></div>
<div class="ttc" id="scconf_8h_html_ab1965c4a7adddaf1672a98d880bd6c21"><div class="ttname"><a href="scconf_8h.html#ab1965c4a7adddaf1672a98d880bd6c21">scconf_put_int</a></div><div class="ttdeci">int scconf_put_int(scconf_block *block, const char *option, int value)</div></div>
<div class="ttc" id="struct__scconf__item_html_af8affd003f82b7208a580ee5cb56da0c"><div class="ttname"><a href="struct__scconf__item.html#af8affd003f82b7208a580ee5cb56da0c">_scconf_item::next</a></div><div class="ttdeci">struct _scconf_item * next</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00067">scconf.h:67</a></div></div>
<div class="ttc" id="struct__scconf__entry_html_ac92588540e8c1d014a08cd8a45462b19"><div class="ttname"><a href="struct__scconf__entry.html#ac92588540e8c1d014a08cd8a45462b19">_scconf_entry::flags</a></div><div class="ttdeci">unsigned int flags</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00034">scconf.h:34</a></div></div>
<div class="ttc" id="struct__scconf__block_html_a0c0f0d9b82294b198e07f8385904e1c2"><div class="ttname"><a href="struct__scconf__block.html#a0c0f0d9b82294b198e07f8385904e1c2">_scconf_block::name</a></div><div class="ttdeci">scconf_list * name</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00079">scconf.h:79</a></div></div>
<div class="ttc" id="scconf_8h_html_ad91ebfa84fe6f6e20a513c6a8fc35de5"><div class="ttname"><a href="scconf_8h.html#ad91ebfa84fe6f6e20a513c6a8fc35de5">scconf_item_add</a></div><div class="ttdeci">scconf_item * scconf_item_add(scconf_context *config, scconf_block *block, scconf_item *item, int type, const char *key, const void *data)</div></div>
<div class="ttc" id="struct__scconf__entry_html_a14c65b9f2783c6f6dafdaaa372329e4d"><div class="ttname"><a href="struct__scconf__entry.html#a14c65b9f2783c6f6dafdaaa372329e4d">_scconf_entry::parm</a></div><div class="ttdeci">void * parm</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00035">scconf.h:35</a></div></div>
<div class="ttc" id="struct__scconf__entry_html"><div class="ttname"><a href="struct__scconf__entry.html">_scconf_entry</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00031">scconf.h:31</a></div></div>
<div class="ttc" id="struct__scconf__item_html"><div class="ttname"><a href="struct__scconf__item.html">_scconf_item</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00066">scconf.h:66</a></div></div>
<div class="ttc" id="scconf_8h_html_a86a492b8747e032923064cc23de2f1b1"><div class="ttname"><a href="scconf_8h.html#a86a492b8747e032923064cc23de2f1b1">scconf_put_bool</a></div><div class="ttdeci">int scconf_put_bool(scconf_block *block, const char *option, int value)</div></div>
<div class="ttc" id="scconf_8h_html_abed028d5efec452b8c2a66ed574e13c5"><div class="ttname"><a href="scconf_8h.html#abed028d5efec452b8c2a66ed574e13c5">scconf_list_destroy</a></div><div class="ttdeci">void scconf_list_destroy(scconf_list *list)</div></div>
<div class="ttc" id="struct__scconf__item_html_aaa2544dbadef96351e62c5a00e20646b"><div class="ttname"><a href="struct__scconf__item.html#aaa2544dbadef96351e62c5a00e20646b">_scconf_item::list</a></div><div class="ttdeci">scconf_list * list</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00073">scconf.h:73</a></div></div>
<div class="ttc" id="struct__scconf__entry_html_a9ce2ec4812a92cb6ab39f6e81e9173a9"><div class="ttname"><a href="struct__scconf__entry.html#a9ce2ec4812a92cb6ab39f6e81e9173a9">_scconf_entry::arg</a></div><div class="ttdeci">void * arg</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00036">scconf.h:36</a></div></div>
<div class="ttc" id="struct__scconf__list_html"><div class="ttname"><a href="struct__scconf__list.html">_scconf_list</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00057">scconf.h:57</a></div></div>
<div class="ttc" id="scconf_8h_html_af464702b43c5ff303ebbde427a6f66ba"><div class="ttname"><a href="scconf_8h.html#af464702b43c5ff303ebbde427a6f66ba">scconf_parse</a></div><div class="ttdeci">int scconf_parse(scconf_context *config)</div></div>
<div class="ttc" id="scconf_8h_html_aeb62022f2fff253f39f1078dacf42f32"><div class="ttname"><a href="scconf_8h.html#aeb62022f2fff253f39f1078dacf42f32">scconf_get_int</a></div><div class="ttdeci">int scconf_get_int(const scconf_block *block, const char *option, int def)</div></div>
<div class="ttc" id="scconf_8h_html_a7ba3f9b01650f48f7f663054f55e3aa1"><div class="ttname"><a href="scconf_8h.html#a7ba3f9b01650f48f7f663054f55e3aa1">scconf_list_array_length</a></div><div class="ttdeci">int scconf_list_array_length(const scconf_list *list)</div></div>
<div class="ttc" id="struct__scconf__block_html_a175c4cc967d747c1d07c892a1b0514d2"><div class="ttname"><a href="struct__scconf__block.html#a175c4cc967d747c1d07c892a1b0514d2">_scconf_block::parent</a></div><div class="ttdeci">scconf_block * parent</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00078">scconf.h:78</a></div></div>
<div class="ttc" id="scconf_8h_html_a6bf939fee559def4804f767a571c0002"><div class="ttname"><a href="scconf_8h.html#a6bf939fee559def4804f767a571c0002">scconf_list_toarray</a></div><div class="ttdeci">const char ** scconf_list_toarray(const scconf_list *list)</div></div>
<div class="ttc" id="struct__scconf__list_html_a91a70b77df95bd8b0830b49a094c2acb"><div class="ttname"><a href="struct__scconf__list.html#a91a70b77df95bd8b0830b49a094c2acb">_scconf_list::data</a></div><div class="ttdeci">char * data</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00059">scconf.h:59</a></div></div>
<div class="ttc" id="struct__scconf__item_html_a5892a9181e6a332f84d27aecd41dcd12"><div class="ttname"><a href="struct__scconf__item.html#a5892a9181e6a332f84d27aecd41dcd12">_scconf_item::key</a></div><div class="ttdeci">char * key</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00069">scconf.h:69</a></div></div>
<div class="ttc" id="struct__scconf__item_html_ac765329451135abec74c45e1897abf26"><div class="ttname"><a href="struct__scconf__item.html#ac765329451135abec74c45e1897abf26">_scconf_item::type</a></div><div class="ttdeci">int type</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00068">scconf.h:68</a></div></div>
<div class="ttc" id="scconf_8h_html_a7eec7e86ab0151ef1be5718ec01088f8"><div class="ttname"><a href="scconf_8h.html#a7eec7e86ab0151ef1be5718ec01088f8">scconf_free</a></div><div class="ttdeci">void scconf_free(scconf_context *config)</div></div>
<div class="ttc" id="structscconf__context_html_a39aebac8fca50ea12a14719c9a36a645"><div class="ttname"><a href="structscconf__context.html#a39aebac8fca50ea12a14719c9a36a645">scconf_context::errmsg</a></div><div class="ttdeci">char * errmsg</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00087">scconf.h:87</a></div></div>
<div class="ttc" id="scconf_8h_html_a447deee631fbbcfd4736954f957faee2"><div class="ttname"><a href="scconf_8h.html#a447deee631fbbcfd4736954f957faee2">scconf_item</a></div><div class="ttdeci">struct _scconf_item scconf_item</div></div>
<div class="ttc" id="struct__scconf__item_html_abba81c977d8901de66b169a60d8481e1"><div class="ttname"><a href="struct__scconf__item.html#abba81c977d8901de66b169a60d8481e1">_scconf_item::block</a></div><div class="ttdeci">scconf_block * block</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00072">scconf.h:72</a></div></div>
<div class="ttc" id="scconf_8h_html_aea883f7131774fcff6ea1dbabd74c963"><div class="ttname"><a href="scconf_8h.html#aea883f7131774fcff6ea1dbabd74c963">scconf_find_blocks</a></div><div class="ttdeci">scconf_block ** scconf_find_blocks(const scconf_context *config, const scconf_block *block, const char *item_name, const char *key)</div></div>
<div class="ttc" id="structscconf__context_html"><div class="ttname"><a href="structscconf__context.html">scconf_context</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00083">scconf.h:83</a></div></div>
<div class="ttc" id="struct__scconf__item_html_a25dae25c3bf9b28d54eb4df7afb2a491"><div class="ttname"><a href="struct__scconf__item.html#a25dae25c3bf9b28d54eb4df7afb2a491">_scconf_item::comment</a></div><div class="ttdeci">char * comment</div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00071">scconf.h:71</a></div></div>
<div class="ttc" id="scconf_8h_html_a7704845802ec646d79a1e1975d69483f"><div class="ttname"><a href="scconf_8h.html#a7704845802ec646d79a1e1975d69483f">scconf_put_str</a></div><div class="ttdeci">const char * scconf_put_str(scconf_block *block, const char *option, const char *value)</div></div>
<div class="ttc" id="scconf_8h_html_a0a2f9633f667675f98dfb2fc220dfc10"><div class="ttname"><a href="scconf_8h.html#a0a2f9633f667675f98dfb2fc220dfc10">scconf_item_copy</a></div><div class="ttdeci">scconf_item * scconf_item_copy(const scconf_item *src, scconf_item **dst)</div></div>
<div class="ttc" id="scconf_8h_html_a4da19211d35bbe397777b33d4f83137a"><div class="ttname"><a href="scconf_8h.html#a4da19211d35bbe397777b33d4f83137a">scconf_block_destroy</a></div><div class="ttdeci">void scconf_block_destroy(scconf_block *block)</div></div>
<div class="ttc" id="scconf_8h_html_aa8f1073e79bcffa437a0050fad1a2b06"><div class="ttname"><a href="scconf_8h.html#aa8f1073e79bcffa437a0050fad1a2b06">scconf_list</a></div><div class="ttdeci">struct _scconf_list scconf_list</div></div>
<div class="ttc" id="scconf_8h_html_a7fb8e0bc1859a8545ce57d99c9c4087b"><div class="ttname"><a href="scconf_8h.html#a7fb8e0bc1859a8545ce57d99c9c4087b">scconf_list_copy</a></div><div class="ttdeci">scconf_list * scconf_list_copy(const scconf_list *src, scconf_list **dst)</div></div>
<div class="ttc" id="scconf_8h_html_ac2d4577c50dd488789375a15c8bb189d"><div class="ttname"><a href="scconf_8h.html#ac2d4577c50dd488789375a15c8bb189d">scconf_get_bool</a></div><div class="ttdeci">int scconf_get_bool(const scconf_block *block, const char *option, int def)</div></div>
<div class="ttc" id="scconf_8h_html_ab915bae0be5ebaca910513630c5d6e81"><div class="ttname"><a href="scconf_8h.html#ab915bae0be5ebaca910513630c5d6e81">scconf_get_str</a></div><div class="ttdeci">const char * scconf_get_str(const scconf_block *block, const char *option, const char *def)</div></div>
<div class="ttc" id="scconf_8h_html_af43e08f4b56609d353887b3bc3e1181b"><div class="ttname"><a href="scconf_8h.html#af43e08f4b56609d353887b3bc3e1181b">scconf_parse_entries</a></div><div class="ttdeci">int scconf_parse_entries(const scconf_context *config, const scconf_block *block, scconf_entry *entry)</div></div>
<div class="ttc" id="scconf_8h_html_a1122f8661ba0177249d248188ba25c18"><div class="ttname"><a href="scconf_8h.html#a1122f8661ba0177249d248188ba25c18">scconf_write_entries</a></div><div class="ttdeci">int scconf_write_entries(scconf_context *config, scconf_block *block, scconf_entry *entry)</div></div>
<div class="ttc" id="struct__scconf__block_html"><div class="ttname"><a href="struct__scconf__block.html">_scconf_block</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00077">scconf.h:77</a></div></div>
<div class="ttc" id="scconf_8h_html_a44356f410df33b5d4566cd7748014402"><div class="ttname"><a href="scconf_8h.html#a44356f410df33b5d4566cd7748014402">scconf_find_block</a></div><div class="ttdeci">const scconf_block * scconf_find_block(const scconf_context *config, const scconf_block *block, const char *item_name)</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
